﻿Imports System.Runtime.InteropServices

Public Class Form1


    Const NETWORK_INTERFACE_INC_USB1770 As Integer = 1

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure INTERFACE_CONFIGURATION
        Public Network_Interface_Type As Integer
        Public Port As Integer
        Public Irq As Integer
        Public ComPort As Integer
        Public ComBaud As Integer
        Public SubType As Integer
        Public Number As Integer
        Public Reserved0 As Integer
        Public Reserved1 As Integer
        Public Reserved2 As Integer
        Public Reserved3 As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=256)> Public AccessPoint() As Byte
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure NODE_CONNECTION_INFO
        Public Explicit_Produce_Size As Short
        Public Explicit_Consume_Size As Short
        Public Explicit_Interval As Short
        Public Explicit_EPR As Short

        Public Poll_Produce_Size As Short
        Public Poll_Consume_Size As Short
        Public Poll_Interval As Short
        Public Poll_EPR As Short

        Public COSCyclic_Produce_Size As Short
        Public COSCyclic_Interval As Short
        Public COSCyclic_ProductionInhibit As Short
        Public AckTimeout As Short

        Public Strobe_EPR As Short
        Public Strobe_Produce_Size As Short
    End Structure




    Private Declare Function LoadDriver Lib "INC_DNET.dll" () As Boolean
    Private Declare Function OpenInterface Lib "INC_DNET.dll" (ByRef DNETHandle As Integer, ByRef InterfaceConfiguration As INTERFACE_CONFIGURATION) As Boolean
    Private Declare Function SetBaud Lib "INC_DNET.dll" (ByVal DNETHandle As Integer, ByVal Baud As Integer) As Boolean
    Private Declare Function SetOnline Lib "INC_DNET.dll" (ByVal DNETHandle As Integer, ByVal State As Boolean) As Boolean
    Private Declare Function SetMacID Lib "INC_DNET.dll" (ByVal DNETHandle As Integer, ByVal MacId As Byte) As Boolean
    Private Declare Function SetExplicitActive Lib "INC_DNET.dll" (ByVal DNETHandle As Integer, ByVal State As Boolean) As Boolean
    Private Declare Function SetPollActive Lib "INC_DNET.dll" (ByVal DNETHandle As Integer, ByVal State As Boolean) As Boolean
    Private Declare Function SetStrobeActive Lib "INC_DNET.dll" (ByVal DNETHandle As Integer, ByVal State As Boolean) As Boolean
    Private Declare Function AddToScanlist Lib "INC_DNET.dll" (ByVal DNETHandle As Integer, ByVal Node As Byte, ByVal ConnType As Byte, ByRef ConnInfo As NODE_CONNECTION_INFO) As Boolean
    Private Declare Function StartScan Lib "INC_DNET.dll" (ByVal DNETHandle As Integer) As Boolean
    Private Declare Function StopScan Lib "INC_DNET.dll" (ByVal DNETHandle As Integer) As Boolean
    Private Declare Function HardwareConfigurationWindow Lib "INC_DNET.dll" (ByRef InterfaceConfiguration As INTERFACE_CONFIGURATION) As Boolean
    Private Declare Function VersionInformationWindow Lib "INC_DNET.dll" (ByVal DNETHandle As Integer) As Boolean
    Private Declare Function CloseInterface Lib "INC_DNET.dll" (ByVal DNETHandle As Integer) As Boolean
    Private Declare Function GetAttribute Lib "INC_DNET.dll" (ByVal DNETHandle As Integer,
                                                                ByVal Node As Byte,
                                                                ByVal cClass As Short,
                                                                ByVal Instance As Short,
                                                                ByVal Attribute As Short,
                                                                ByRef GetSize As Short,
                                                                ByRef Data As Byte
                                                                ) As Boolean


    Dim InterfaceConfiguration As New INTERFACE_CONFIGURATION()
    Dim InterfaceHandle As Integer
    Dim bDriverLoaded As Boolean


    Private Sub ButtonOpenInterface_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOpenInterface.Click
        Dim bResult As Boolean
        Dim lastError As Integer

        If (bDriverLoaded <> True) Then
            ReDim InterfaceConfiguration.AccessPoint(255)
            bDriverLoaded = LoadDriver()
        End If

        bResult = OpenInterface(InterfaceHandle, InterfaceConfiguration)

        If (bResult = True) Then
            bResult = SetBaud(InterfaceHandle, 125000)
            bResult = SetMacID(InterfaceHandle, 1)
            bResult = SetOnline(InterfaceHandle, True)
        Else
            lastError = Err.LastDllError
        End If
    End Sub

    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCloseInterface.Click
        CloseInterface(InterfaceHandle)
    End Sub

    Private Sub ButtonConfigure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonConfigure.Click
        If (bDriverLoaded <> True) Then
            ReDim InterfaceConfiguration.AccessPoint(255)
            bDriverLoaded = LoadDriver()
        End If

        InterfaceConfiguration.Network_Interface_Type = NETWORK_INTERFACE_INC_USB1770
        InterfaceConfiguration.AccessPoint(0) = &H34
        InterfaceConfiguration.AccessPoint(1) = &H35
        InterfaceConfiguration.AccessPoint(2) = &H36
        InterfaceConfiguration.AccessPoint(3) = 0
        HardwareConfigurationWindow(InterfaceConfiguration)

    End Sub

    Private Sub ButtonStartScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStartScan.Click
        Dim ConnInfo As New NODE_CONNECTION_INFO()
        Dim Node As Byte
        Dim bResult As Boolean

        ConnInfo.Explicit_Consume_Size = 32
        ConnInfo.Explicit_Produce_Size = 32
        ConnInfo.Explicit_Interval = 1000 '1 second interval
        ConnInfo.Explicit_EPR = 2500 '10 second timeout for epr = value *4
        Node = 2
        bResult = AddToScanlist(InterfaceHandle, Node, 1, ConnInfo)
        bResult = StartScan(InterfaceHandle)

    End Sub

    Private Sub ButtonStopScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStopScan.Click
        StopScan(InterfaceHandle)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim bResult As Boolean
        Dim Data(32) As Byte
        Dim GetSize As Short
        Dim SerialNumber As Integer


        bResult = GetAttribute(InterfaceHandle, 2, 1, 1, 6, GetSize, Data(0))
        If (bResult) Then
            SerialNumber = Data(3) * 16777216
            SerialNumber = SerialNumber + Data(2) * 65536
            SerialNumber = SerialNumber + Data(1) * 256
            SerialNumber = SerialNumber + Data(0)
            TextBoxSerial.Text = SerialNumber
        End If

    End Sub
End Class
